/**
 * @file toy_common.c
 *
 * @copyright Copyright  (C)  2014 DKRZ, MPI-M
 *
 * @version 1.0
 *
 * @author Moritz Hanke <hanke@dkrz.de>
 *         Rene Redler  <rene.redler@mpimet.mpg.de>
 *
 */
/*
 * Keywords:
 *
 * Maintainer: Moritz Hanke <hanke@dkrz.de>
 *             Rene Redler  <rene.redler@mpimet.mpg.de>
 *
 * URL: https://doc.redmine.dkrz.de/YAC/html/index.html
 *
 * This file is part of YAC.
 *
 * YAC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * YAC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with YAC.  If not, see <http://www.gnu.org/licenses/gpl.txt>.
 *
 */

#undef TOY_SETTING

//#define two_fields

#if defined one_field

  const char * fieldName[] = {"field1_atm_oce",
                              "field1_oce_atm"};

  const char * xml_filename = "coupling_toy_1.xml";

#elif defined two_fields

  const char * fieldName[] = {"field1_atm_oce",
                              "field2_atm_oce",
                              "field1_oce_atm",
                              "field2_oce_atm"};

  const char * xml_filename = "coupling_toy_2.xml";

#elif defined four_fields

  const char * fieldName[] = {"field1_atm_oce",
                              "field2_atm_oce",
                              "field3_atm_oce",
                              "field4_atm_oce",
                              "field1_oce_atm",
                              "field2_oce_atm",
                              "field3_oce_atm",
                              "field4_oce_atm"};
  const char * xml_filename = "coupling_toy_4.xml";

#else

#define TOY_SETTING

  const char * fieldName[] = {"conserv_field_atm_oce",
                              "patch_field_atm_oce",
                              "conserv_field_oce_atm",
                              "patch_field_oce_atm"};
  const char * xml_filename = "coupling_toy.xml";

#endif

const char * xsd_filename = "coupling.xsd";
const int num_steps = 1;
