package de.mpg.mpimet.yacgui.controller;

import de.mpg.mpimet.yacgui.ui.CouplingGui;

/**
 * Helper class to track the status of a file (saved or not).
 * 
 * @author teresa
 */
public class FileStatus {
	
	private boolean saved;
	private CouplingGui gui;
	
	/**
	 * FileStatus of a coupling XML file, manipulates given CouplingGui.
	 * 
	 * <p>
	 * FileStatus is initialized with <b><code>saved = true</code></b>.
	 * 
	 * @param gui	GUI to be manipulated
	 */
	public FileStatus(CouplingGui gui) {
		this.gui = gui;
		save();
	}

	public void edit() {
		saved = false;
		gui.setTitleUnsaved();
		gui.setMenuFileSaveEnabled(true);
	}
	
	public void save() {
		saved = true;
		gui.setTitleSaved();
		gui.setMenuFileSaveEnabled(false);
	}
	
	public boolean isSaved() {
		return saved;
	}
}
