package de.mpg.mpimet.yacgui.model;

import de.mpg.mpimet.yacgui.model.Model.Align;

public class IllegalConnectionException extends Exception {

	private static final long serialVersionUID = 5789085745413238193L;
	
	public IllegalConnectionException(Align sourceAlign, int sourceIndex, int targetIndex, String message) {
		super(createMessagePrefix(sourceAlign, sourceIndex, targetIndex) + message);
	}

	public IllegalConnectionException(Align sourceAlign, int sourceIndex, int targetIndex, String message, Throwable throwable) {
		super(createMessagePrefix(sourceAlign, sourceIndex, targetIndex) + message, throwable);
	}

	private static String createMessagePrefix(Align sourceAlign, int sourceIndex, int targetIndex) {
		String messagePrefix = "Connection " + sourceAlign.toString() + ":" + sourceIndex 
				+ "->" + sourceAlign.getOpposite().toString() + ":" + targetIndex + " : ";
		return messagePrefix;
	}
}
