package de.mpg.mpimet.yacgui.ui.dialog.tabpanel;

import java.awt.Component;

import javax.swing.BoxLayout;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;

import de.mpg.mpimet.yacgui.xml.TransientCouple;

public abstract class AbstractTab extends JPanel {
	
	public interface onCouplingDialogEventsListener {
		void updateWindowSize();
	}

	private static final long serialVersionUID = 2049961763853894034L;

	protected String dialogDescription;
	protected TransientCouple transientCouple;
	
	public AbstractTab(String dialogDescription, TransientCouple transientCouple) {
		this.dialogDescription = dialogDescription;
		this.transientCouple = transientCouple;
	}
	
	protected void createLayout() {
		setLayout(new BoxLayout(this, BoxLayout.PAGE_AXIS));
		add(createCaption());
		add(createCenterPanel());
	}

	protected JLabel createCaption() {
		JLabel label = new JLabel(convertToMultiline(dialogDescription));
		label.setAlignmentX(Component.CENTER_ALIGNMENT);
		label.setBorder(new EmptyBorder(5, 5, 5, 5));
		return label;
	}
	
	public static String convertToMultiline(String orig) {
	    return "<html>" + orig.replaceAll("\n", "<br>") + "</html>";
	}
	
	protected abstract JComponent createCenterPanel();
	public abstract void loadParameters();
}
