package de.mpg.mpimet.yacgui.ui.dialog.tabpanel;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import de.mpg.mpimet.yacgui.ui.XmlFileChooser;

public class FilenamePanel extends JPanel {

	private static final long serialVersionUID = -421935109521226338L;
	
	private static final String LABEL_FILE = "file: ";
	private static final String LABEL_BROWSE = "Browse";

	private JTextField filenameField;
	private JButton browseButton;
	
	public FilenamePanel() {
		super();
		
		add(new JLabel(LABEL_FILE));
		filenameField = new JTextField(20);
		add(filenameField);
		browseButton = new JButton(LABEL_BROWSE);
		add(browseButton);
		browseButton.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				File file = XmlFileChooser.chooseFileOpen(FilenamePanel.this);
				if (file != null) {
					filenameField.setText(file.getAbsolutePath());
				}
			}
		});
	}
	
	public String getFilename() {
		return filenameField.getText();
	}
	
	public void setFilename(String filename) {
		if (filenameField != null) {
			filenameField.setText(filename);
		}
	}
	
	@Override
	public void setEnabled(boolean enabled) {
		super.setEnabled(enabled);
		
		filenameField.setEnabled(enabled);
		browseButton.setEnabled(enabled);
	}

	public void clean() {
		setFilename(null);
	}
}
