package de.mpg.mpimet.yacgui.xml;

public enum Calendar {

	PROLEPTIC_GREGORIAN("proleptic-gregorian"),
	REGULAR_360D("360d"),
	REGULAR_365D("365d");
	
	private final String name;
	
	private Calendar(String s) {
		name = s;
	}
	
	public boolean equalsName(String otherName) {
		return (otherName == null) ? false : name.equals(otherName);
	}
	
	public static Calendar objectFromString(String name) {
		if (name == null) {
			return null;
		}
		
		if (name.equals(PROLEPTIC_GREGORIAN.name)) {
			return PROLEPTIC_GREGORIAN;
		} else if (name.equals(REGULAR_360D.name)) {
			return REGULAR_360D;
		} else if (name.equals(REGULAR_365D.name)) {
			return REGULAR_365D;
		} else {
			return PROLEPTIC_GREGORIAN;
		}
	}
	
	/**
	 * @return String representation of Calendar, e.g. "proleptic-gregorian".
	 */
	@Override
	public String toString() {
		return name;
	}
}
