package de.mpg.mpimet.yacgui.xml;

public enum CouplingOperation {
	
	ACCUMULATE("accumulate"), 
	AVERAGE("average"), 
	NONE("none");
	
	private final String name;
	
	private CouplingOperation(String s) {
		name = s;
	}
	
	public boolean equalsName(String otherName) {
		return (otherName == null) ? false : name.equals(otherName);
	}
	
	public static CouplingOperation objectFromString(String name) {
		if (name == null) return null;
		if (name.equals(ACCUMULATE.name)) return ACCUMULATE;
		else if (name.equals(AVERAGE.name)) return AVERAGE;
		else return NONE;
	}
	
	public static String[] toStringArray() {
		return new String[] { ACCUMULATE.name, AVERAGE.name, NONE.name };
	}
	
	/**
	 * @return String representation of CouplingOperation, e.g. "average".
	 */
	@Override
	public String toString() {
		return name;
	}
}
