package de.mpg.mpimet.yacgui.xml;

/**
 * Java representation of {@code <dates>} xml element.
 * 
 * @author Maxim Yastremsky
 */
public class Dates {
	
	private String startDate;
	
	private String endDate;
	
	private Calendar calendar;

	public Dates(String startDate, String endDate, Calendar calendar) {
		this.startDate = startDate;
		this.endDate = endDate;
		this.calendar = calendar;
	}

	public String getStartDate() {
		return startDate;
	}

	public String getEndDate() {
		return endDate;
	}
	
	public Calendar getCalendar() {
		return calendar;
	}

	public void setStartDate(String startDate) {
		this.startDate = startDate;
	}

	public void setEndDate(String endDate) {
		this.endDate = endDate;
	}
	
	public void setCalendar(Calendar calendar) {
		this.calendar = calendar;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((calendar == null) ? 0 : calendar.hashCode());
		result = prime * result + ((endDate == null) ? 0 : endDate.hashCode());
		result = prime * result + ((startDate == null) ? 0 : startDate.hashCode());
		return result;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (!(obj instanceof Dates)) {
			return false;
		}
		Dates other = (Dates) obj;
		if (calendar != other.calendar) {
			return false;
		}
		if (endDate == null) {
			if (other.endDate != null) {
				return false;
			}
		} else if (!endDate.equals(other.endDate)) {
			return false;
		}
		if (startDate == null) {
			if (other.startDate != null) {
				return false;
			}
		} else if (!startDate.equals(other.startDate)) {
			return false;
		}
		return true;
	}

}
