package de.mpg.mpimet.yacgui.xml;

/**
 * String constants for &lt;coupling&gt; and &lt;component&gt; xml Java 
 * representations.<br>
 *
 * Element names and attribtue names according to coupling.xsd and 
 * component.xsd.
 */
public class Dom {
	
	public static final String COUPLING = "coupling";
	public static final String REDIRECT = "redirect";
	public static final String COMPONENTS = "components";
	public static final String TRANSIENTS = "transients";
	public static final String TRANSIENT_GRID_REFS = "transient_grid_refs";
	public static final String GRIDS = "grids";
	public static final String DATES = "dates";
	public static final String START_DATE = "start_date";
	public static final String END_DATE = "end_date";
	public static final String CALENDAR = "calendar";
	public static final String TIMESTEP_UNIT = "timestep_unit";
	public static final String COUPLES = "couples";
	public static final String COMPONENT = "component";
	public static final String ID = "id";
	public static final String NAME = "name";
	public static final String MODEL = "model";
	public static final String SIMULATED = "simulated";
	public static final String TIMESTEP = "timestep";
	public static final String TRANSIENT = "transient";
	public static final String TRANSIENT_GRID_REF = "transient_grid_ref";
	public static final String GRID = "grid";
	public static final String COUPLE = "couple";
	public static final String COMPONENT1 = "component1";
	public static final String COMPONENT2 = "component2";
	public static final String TRANSIENT_COUPLE = "transient_couple";
	public static final String SOURCE = "source";
	public static final String TARGET = "target";
	public static final String COUPLING_PERIOD = "coupling_period";
	public static final String SOURCE_TIMELAG = "source_timelag";
	public static final String TARGET_TIMELAG = "target_timelag";
	public static final String INTERPOLATION_REQUIREMENTS = "interpolation_requirements";
	public static final String INTERPOLATION = "interpolation";
	public static final String MASK_VALUE = "mask_value";
	public static final String DEBUG_MODE = "debug_mode";
	public static final String ENFORCE_WRITE_RESTART = "enforce_write_restart";
	public static final String ENFORCE_WRITE_WEIGHT_FILE = "enforce_write_weight_file";
	
	public static final String CREATED = "created";
	
	public class Attribute {
		public static final String XMLNS = "xmlns";
		public static final String XMLNS_XSI = "xmlns:xsi";
		public static final String XSI_SCHEMALOCATION = "xsi:schemaLocation";
		
		public static final String REDIRECT_STDOUT = "redirect_stdout";
		public static final String REDIRECT_OF_ROOT = "redirect_of_root";
		public static final String ID = "id";
		public static final String TRANSIENT_REF = "transient_ref";
		public static final String GRID_REF = "grid_ref";
		public static final String COLLECTION_SIZE = "collection_size";
		public static final String TRANSIENT_STANDARD_NAME = "transient_standard_name";
		public static final String ALIAS_NAME = "alias_name";
		public static final String COMPONENT_ID = "component_id";
		public static final String TRANSIENT_ID = "transient_id";
		public static final String COMPONENT_REF = "component_ref";
		public static final String TRANSIENT_GRID_REF = "transient_grid_ref";
		public static final String OPERATION = "operation";
		public static final String USE_SOURCE_MASK = "use_source_mask";
		public static final String USE_TARGET_MASK = "use_target_mask";
		public static final String METHOD = "method";
		public static final String MASK_HANDLING = "mask_handling";
		
		public static final String N = "n";
		public static final String WEIGHTED = "weighted";
		
		public static final String ENFORCED_CONSERVATION = "enforced_conservation";
		public static final String PARTIAL_COVERAGE = "partial_coverage";
		public static final String NORMALISATION = "normalisation";
		
		public static final String ALLOW_EXTRAPOLATION = "allow_extrapolation";
		public static final String EXTEND_SOURCE_PATCH = "extend_source_patch";
		public static final String POLYNOMIAL_ORDER = "polynomial_order";
		public static final String GAUSS_ORDER = "gauss_order";
		public static final String ALLOW_CORNER_WEIGHT = "allow_corner_weight";
		public static final String CORNER_WEIGHT = "corner_weight";

		
		public static final String USER_VALUE = "user_value";		
		public static final String AT_SOURCE_BEFORE_INTERPOLATION = "at_source_before_interpolation";
		public static final String AT_SOURCE_AFTER_INTERPOLATION = "at_source_after_interpolation";
		public static final String AT_TARGET = "at_target";
		
		public static final String FILENAME = "filename";
		public static final String YAC_LOCATION = "yac_location";
		
		public static final String DATE = "date";
		public static final String TOOL = "tool";
	}
	
	public class Value {
		public static final String XMLNS = "http://www.w3schools.com"; 
		public static final String XMLNS_XSI = "http://www.w3.org/2001/XMLSchema-instance";
		public static final String XSI_SCHEMALOCATION = "http://www.w3schools.com coupling.xsd";
		public static final String NONE = "none";
		public static final String PARTIAL_AVERAGE = "partial_average";
		
		public static final String FRACAREA = "FRACAREA";
		public static final String DESTAREA = "DESTAREA";
		
		public static final String CELL = "CELL";
		public static final String EDGE = "EDGE";
		public static final String CORNER = "CORNER";
		
		public static final String DISTANCE_WEIGHTED = "DISTANCE_WEIGHTED";
		public static final String ARITHMETIC_AVERAGE = "ARITHMETIC_AVERAGE";
	}
}
