package de.mpg.mpimet.yacgui.xml;

/**
 * Java representation of {@code <transient>}.
 * 
 * @author Maxim Yastremsky
 */
public class Transient {
	
	private int id;
	private String transientStandardName;

	public Transient(int id, String transientStandardName) {
		this.id = id;
		this.transientStandardName = transientStandardName;
	}
	
	public int getId() {
		return id;
	}
	
	public void setId(int id) {
		this.id = id;
	}

	public String getTransientStandardName() {
		return transientStandardName;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + id;
		result = prime
				* result
				+ ((transientStandardName == null) ? 0 : transientStandardName
						.hashCode());
		return result;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (!(obj instanceof Transient)) {
			return false;
		}
		Transient other = (Transient) obj;
		if (id != other.id) {
			return false;
		}
		if (transientStandardName == null) {
			if (other.transientStandardName != null) {
				return false;
			}
		} else if (!transientStandardName.equals(other.transientStandardName)) {
			return false;
		}
		return true;
	}

}
