package de.mpg.mpimet.yacgui.xml.interpolation;

import de.mpg.mpimet.yacgui.xml.Dom;

/**
 * Definite interpolation method fixed value
 * 
 * @author Maxim Yastremsky
 */
public class FixedValueInterpolation extends Interpolation {
	
	private double userValue;
	
	public FixedValueInterpolation(double userValue) {
		attributesNumber = 1;
		method = InterpolationMethod.FIXED_VALUE;
		this.userValue = userValue;
	}
	
	/**
	 * 
	 * @return a fixed value given by user which is assigned to target cells or points
	 */
	public double getUserValue() {
		return userValue;
	}
	
	/**
	 * get attribute name by the order of index
	 * @param index the order of attributes on the panel
	 * @return  the name of attribute
	 * 				index = 0 return USER_VALUE
	 */
	public String getAttributeName(int index) {
		if (index == 0) {
			return Dom.Attribute.USER_VALUE;
		}
		return null;
	}
	
	/**
	 * get attribute value by the order of index
	 * @param index the order of attributes on the panel
	 * @return the value of attribute as String
	 * 				only case that index is 0, return user value
	 */
	public String getAttributeValue(int index) {
		if (index == 0) {
			return String.valueOf(userValue);
		}
		return null;
	}

}
