package de.mpg.mpimet.yacgui.xml.interpolation;

/**
 * Base class for all types of interpolations.
 * 
 * @author Maxim Yastremsky
 */
public abstract class Interpolation {
	//the name of interpolation method
	protected InterpolationMethod method;
    //the number of all the parameters of this method
	protected int attributesNumber;
	
	public InterpolationMethod getMethod() {
		return method;
	}

	public int getAttributesNumber() {
		return attributesNumber;
	}
	
	public String getAttributeName(int index) {
		return null;
	}
	
	public String getAttributeValue(int index) {
		return null;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((method == null) ? 0 : method.hashCode());
		return result;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (!(obj instanceof Interpolation)) {
			return false;
		}
		Interpolation other = (Interpolation) obj;
		if (method != other.method) {
			return false;
		}
		return true;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "Interpolation [method=" + method + ", attributesNumber="
				+ attributesNumber + "]";
	}
	
}
