dnl
dnl Copyright  (C)  2017  Thomas Jahns <jahns@dkrz.de>
dnl
dnl Version: 1.0
dnl Keywords: configure configure.ac autotools
dnl Author: Thomas Jahns <jahns@dkrz.de>
dnl Maintainer: Thomas Jahns <jahns@dkrz.de>
dnl URL: https://doc.redmine.dkrz.de/YAC/html/index.html
dnl
dnl Redistribution and use in source and binary forms, with or without
dnl modification, are  permitted provided that the following conditions are
dnl met:
dnl
dnl Redistributions of source code must retain the above copyright notice,
dnl this list of conditions and the following disclaimer.
dnl
dnl Redistributions in binary form must reproduce the above copyright
dnl notice, this list of conditions and the following disclaimer in the
dnl documentation and/or other materials provided with the distribution.
dnl
dnl Neither the name of the DKRZ GmbH nor the names of its contributors
dnl may be used to endorse or promote products derived from this software
dnl without specific prior written permission.
dnl
dnl THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
dnl IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
dnl TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
dnl PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
dnl OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
dnl EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
dnl PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
dnl PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
dnl LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
dnl NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
dnl SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
dnl
dnl ACX_C99_LDBL_MAX_GT_DBL_MAX_IFELSE([IF-RANGE-IS-GREATER],
dnl                                    [IF-RANGE-IS-EQUAL])
dnl test that long double provides a greater range than double
AC_DEFUN([ACX_C99_TEST_LDBL_MAX_GT_DBL_MAX],
  [AC_CACHE_CHECK([if long double has greater range than double],
     [acx_cv_c99_assert_ldbl_max_gt_dbl_max],
     [AC_COMPILE_IFELSE([AC_LANG_PROGRAM([@%:@include <float.h>
@%:@include <math.h>
@%:@include <stdio.h>
@%:@include <stdlib.h>],[int a@<:@(LDBL_MAX > DBL_MAX)@:>@;
a@<:@0@:>@ = 1;
printf("%d\n", a@<:@0@:>@);
return EXIT_SUCCESS;
])],[acx_cv_c99_assert_ldbl_max_gt_dbl_max=yes],
        [acx_cv_c99_assert_ldbl_max_gt_dbl_max=no])])
   AS_IF([test $acx_cv_c99_assert_ldbl_max_gt_dbl_max = yes],[$1],
     m4_ifval([$2],[$2],[AC_MSG_FAILURE([range of long double is too small])]))])
dnl
dnl Local Variables:
dnl license-project-url: "https://doc.redmine.dkrz.de/YAC/html/index.html"
dnl license-default: "bsd"
dnl mode: autoconf
dnl End:
