/**
 * @file mask.c
 *
 * @copyright Copyright  (C)  2013 Moritz Hanke <hanke@dkrz.de>
 *
 * @version 1.0
 * @author Moritz Hanke <hanke@dkrz.de>
 */
/*
 * Keywords:
 * Maintainer: Moritz Hanke <hanke@dkrz.de>
 * URL: https://doc.redmine.dkrz.de/YAC/html/index.html
 *
 * This file is part of YAC.
 *
 * YAC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * YAC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with YAC.  If not, see <http://www.gnu.org/licenses/gpl.txt>.
 */

#include <stdlib.h>
#include <string.h>

#include "points.h"
#include "mask.h"

void yac_init_mask(struct mask * mask, unsigned const * mask_values,
                   struct points * points) {

   static unsigned unique_id = 0;

   unsigned num_points;

   num_points = yac_get_data_size(*points);

   mask->mask = malloc(num_points * sizeof(*(mask->mask)));
   memcpy(mask->mask, mask_values, num_points * sizeof(*(mask->mask)));
   mask->unique_id = unique_id++;
}

void yac_free_mask(struct mask * mask) {

   free(mask->mask);
   mask->mask = NULL;
}
