/**
 * @file interpolation_enum.h
 *
 * @copyright Copyright  (C)  2013 Rene Redler <rene.redler@mpimet.mpg.de>
 *                                 Teresa Holfeld <teresa.holfeld@zmaw.de>
 *
 * @version 1.0
 * @author Rene Redler <rene.redler@mpimet.mpg.de>
 *         Teresa Holfeld <teresa.holfeld@zmaw.de>
 */
/*
 * Keywords:
 * Maintainer: Rene Redler <rene.redler@mpimet.mpg.de>
 *             Teresa Holfeld <teresa.holfeld@zmaw.de>
 * URL: https://doc.redmine.dkrz.de/YAC/html/index.html
 *
 * This file is part of YAC.
 *
 * YAC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * YAC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with YAC.  If not, see <http://www.gnu.org/licenses/gpl.txt>.
 */

#ifndef INTERPOLATION_ENUM_H_
#define INTERPOLATION_ENUM_H_

enum yac_interpolation_list {
   UNDEFINED             = 0,
   AVERAGE               = 1,
   N_NEAREST_NEIGHBOR    = 2,
   CONSERVATIVE          = 3,
   PATCH_RECOVERY        = 4,
   SMOOTH_PATCH_RECOVERY = 5,
   SOURCE_TO_TARGET_MAP  = 6,
   FIXED_VALUE           = 7,
   USER_FILE             = 8,
   CHECK                 = 9,
};

char * yac_interpolation_enum_to_string(const enum yac_interpolation_list interpolation);

char * yac_interpolation_int_to_string(const int interpolation);

enum yac_interpolation_list yac_interpolation_enum_from_string(const char * interpolation);

/**
 * Verifies if interpolation string matches one of the given interpolation
 * methods in enum.
 *
 * @return the interpolation string, or "user_defined" if string doesn't match
 */
char * yac_verified_interpolation(const char * interpolation);

#endif /* INTERPOLATION_ENUM_H_ */
