/**
 * @file yac_init.c
 *
 * @copyright Copyright  (C)  2013 Rene Redler <rene.redler@mpimet.mpg.de>
 *                                 Thomas Jahns <jahns@dkrz.de>
 *
 * @version 1.0
 * @author Rene Redler <rene.redler@mpimet.mpg.de>
 *         Thomas Jahns <jahns@dkrz.de>
 */
/*
 * Keywords:
 * Maintainer: Rene Redler <rene.redler@mpimet.mpg.de>
 *             Thomas Jahns <jahns@dkrz.de>
 * URL: https://doc.redmine.dkrz.de/YAC/html/index.html
 *
 * This file is part of YAC.
 *
 * YAC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * YAC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with YAC.  If not, see <http://www.gnu.org/licenses/gpl.txt>.
 */

#include <stdio.h>
#include <string.h>
#include "config_xml.h"
#include "yacpar.h"
#include "communicator_mpi.h"
#include "communicator_local.h"

struct communicator * yac_world_comm = NULL;

void yac_init ( const char * xml_filename, const char * schema_filename ) {

  /* Get the XML configuration tree */
#ifdef USE_XML2
  yac_xml_init_config_xml ( xml_filename , schema_filename );
#endif

#ifdef USE_MPI 
  /* calling MPI_Init if required and returning a copy of MPI_COMM_WORLD */
  yac_world_comm = yac_mpi_comm_new();
#else
  yac_world_comm = yac_local_comm_new();
#endif

  return;
}
