!!
!! @file test_def_comps.F90
!!
!! @copyright Copyright  (C)  2017 DKRZ, MPI-M
!!
!! @version 1.0
!!
!! @author Moritz Hanke <hanke@dkrz.de>
!!         Rene Redler  <rene.redler@mpimet.mpg.de>
!!
! 
!  Keywords:
! 
!  Maintainer: Moritz Hanke <hanke@dkrz.de>
!              Rene Redler  <rene.redler@mpimet.mpg.de>
! 
!  URL: https://doc.redmine.dkrz.de/YAC/html/index.html
! 
!  This file is part of YAC.
! 
!  YAC is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
! 
!  YAC is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
! 
!  You should have received a copy of the GNU General Public License
!  along with YAC.  If not, see <http://www.gnu.org/licenses/gpl.txt>.
! 
!

#include "test_macros.inc"

program test_def_comps

  use utest
  use mo_yac_finterface, only : yac_fdef_comps, YAC_MAX_CHARLEN
  implicit none

  integer :: comp_ids(2)

  character(len=YAC_MAX_CHARLEN) :: comp_names(2)
  character(len=YAC_MAX_CHARLEN) :: xml_name
  character(len=YAC_MAX_CHARLEN) :: schema_name

  logical  :: result

  call start_test("def_comps")

  comp_ids = -99

  xml_name    = 'coupling.xml'
  schema_name = 'coupling.xsd'
  call yac_finit ( xml_name , schema_name )

  comp_names(1) = 'ICON-ocean'
  comp_names(2) = 'ICON-atmosphere'
  call yac_fdef_comps ( comp_names, 2, comp_ids )

#ifdef VERBOSE
  print *, ' def_comps returned comp_ids ', comp_ids
#endif

  result = ALL( comp_ids(:) /= -99 )

  call test ( result )

  call yac_ffinalize ( );

  call stop_test

  call exit_tests

end program test_def_comps
