!!
!! @file test_def_grid.F90
!!
!! @copyright Copyright  (C)  2013 DKRZ, MPI-M
!!
!! @version 1.0
!!
!! @author Moritz Hanke <hanke@dkrz.de>
!!         Rene Redler  <rene.redler@mpimet.mpg.de>
!!
! 
!  Keywords:
! 
!  Maintainer: Moritz Hanke <hanke@dkrz.de>
!              Rene Redler  <rene.redler@mpimet.mpg.de>
! 
!  URL: https://doc.redmine.dkrz.de/YAC/html/index.html
! 
!  This file is part of YAC.
! 
!  YAC is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
! 
!  YAC is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
! 
!  You should have received a copy of the GNU General Public License
!  along with YAC.  If not, see <http://www.gnu.org/licenses/gpl.txt>.
! 
!

#include "test_macros.inc"

program test_def_subdomain

  use utest
  use mo_yac_finterface, only : yac_fdef_comp, &
                                yac_fdef_subdomain, YAC_MAX_CHARLEN
  implicit none

  integer :: comp_id
  integer :: subdomain_id(2)

  integer, parameter :: ndim = 3

  character(len=YAC_MAX_CHARLEN) :: comp_name
  character(len=YAC_MAX_CHARLEN) :: grid_name
  character(len=YAC_MAX_CHARLEN) :: xml_name
  character(len=YAC_MAX_CHARLEN) :: schema_name

  logical  :: result

  call start_test("def_subdomain")

  subdomain_id = -99

  xml_name    = 'coupling.xml'
  schema_name = 'coupling.xsd'
  call yac_finit ( xml_name , schema_name )

  comp_name   = 'ICON-ocean'
  call yac_fdef_comp ( comp_name, comp_id )

#ifdef VERBOSE
  print *, ' def_comp returned comp_id ', comp_id
#endif

  grid_name = 'name1'

  call yac_fdef_subdomain ( comp_id,    &
                            grid_name,  &
                            subdomain_id(1) )

  result = ( subdomain_id(1) /= -99 )

  call test ( result )

#ifdef VERBOSE
  print *, ' def_subdomain returned subdomain_id ', subdomain_id(1)
#endif

  call yac_fdef_subdomain ( comp_id,    &
                            grid_name,  &
                            subdomain_id(2) )

  result = ( subdomain_id(2) /= -99 )

  call test ( result )

#ifdef VERBOSE
  print *, ' def_subdomain returned subdomain_id ', subdomain_id(2)
#endif

  call yac_ffinalize ( );

  call stop_test

  call exit_tests

end program test_def_subdomain
