/**
 * @file test_pole_cover.c
 *
 * @copyright Copyright  (C)  2013 DKRZ, MPI-M
 *
 * @version 1.0
 *
 * @author Moritz Hanke <hanke@dkrz.de>
 *
 */
/*
 * Keywords:
 *
 * Maintainer: Moritz Hanke <hanke@dkrz.de>
 *
 * URL: https://doc.redmine.dkrz.de/YAC/html/index.html
 *
 * This file is part of YAC.
 *
 * YAC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * YAC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with YAC.  If not, see <http://www.gnu.org/licenses/gpl.txt>.
 *
 */

#include "tests.h"
#include "search.h"

int main (void) {

   double clon[5], clat[5];

   unsigned i;

   for (i = 0; i < 5; ++i) clat[i] = 88;

   clon[0] =  10*rad;
   clon[1] =  70*rad;
   clon[2] = 130*rad;
   clon[3] = 190*rad;
   clon[4] = 250*rad;

   if (!yac_cell_covers_pole(5, clon, clat))
      PUT_ERR("error in yac_cell_covers_pole first test")

   clat[0] = 88.0*rad; clon[0] =  50.0*rad;
   clat[1] = 88.0*rad; clon[1] =  70.0*rad;
   clat[2] = 89.0*rad; clon[2] =  75.0*rad;
   clat[3] = 89.5*rad; clon[3] =  60.0*rad;
   clat[4] = 89.0*rad; clon[4] =  45.0*rad;

   if (yac_cell_covers_pole(5, clon, clat))
      PUT_ERR("error in yac_cell_covers_pole second test")

   clat[0] = -10*rad; clon[0] =  300*rad;
   clat[1] = -10*rad; clon[1] =   60*rad; // 420*rad
   clat[2] =  10*rad; clon[2] =   60*rad; // 420*rad
   clat[3] =  10*rad; clon[3] =  300*rad;

   if (yac_cell_covers_pole(4, clon, clat))
      PUT_ERR("error in yac_cell_covers_pole third test")

   return TEST_EXIT_CODE;
}
