/**
 * @file test_quicksort.c
 *
 * @copyright Copyright  (C)  2013 DKRZ, MPI-M
 *
 * @version 1.0
 *
 * @author Moritz Hanke <hanke@dkrz.de>
 *         Rene Redler  <rene.redler@mpimet.mpg.de>
 *
 */
/*
 * Keywords:
 *
 * Maintainer: Moritz Hanke <hanke@dkrz.de>
 *             Rene Redler  <rene.redler@mpimet.mpg.de>
 *
 * URL: https://doc.redmine.dkrz.de/YAC/html/index.html
 *
 * This file is part of YAC.
 *
 * YAC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * YAC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with YAC.  If not, see <http://www.gnu.org/licenses/gpl.txt>.
 *
 */

#include <stdlib.h>
#include <stdio.h>
#include "utils.h"
#include "tests.h"

#define LEN 128

int main (void) {

   int a[LEN];
   int idx[LEN];
   int len;

   int i;

   len = LEN;

   for (i = 0; i < len; ++i) {
     a[i]   = len-i-1;
     idx[i] = i;
   }

#ifdef VERBOSE
   for (i = 0; i < len; ++i) {
     printf ("Unsorted list is i=%i  a[i]=%i idx[i]=%i\n ", i, a[i], idx[i]); 
   }
#endif

   yac_quicksort_index ( a, len, idx );

   for (i = 0; i < len; ++i) {

     if ((i != a[i]) || (idx[i] != len-i-1)) INC_ERR;

#ifdef VERBOSE
     printf ("Sorted list is i=%i  a[i]=%i idx[i]=%i\n ", i, a[i], idx[i]);
#endif
   }

   return TEST_EXIT_CODE;
}
